"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const child_process = require("mz/child_process");
const utility_1 = require("../utility");
class Language {
    constructor(name, ext, getSource = (filePath) => utility_1.getFileContents(filePath)) {
        this.name = name;
        this.ext = ext;
        this.getSource = getSource;
        Language.instances.forEach(lang => {
            if (lang.name === this.name || lang.ext === this.ext) {
                throw new Error("Duplicate language definition!");
            }
        });
        Language._instances.push(this);
        const middle = Language.instances
            .map(lang => lang.ext)
            .reduce((result, extension, index) => result + (index !== 0 ? "$|" : "") + ".*\\" + extension, "");
        Language.ignoreRegExp = new RegExp("^(.(?!" + middle + "))*$");
    }
    remove() {
        const index = Language.instances.indexOf(this);
        if (index > -1) {
            Language._instances.splice(index, 1);
        }
    }
}
Language._instances = new Array();
Language.instances = Language._instances;
Language.ignoreRegExp = new RegExp("^$");
exports.default = Language;
new Language("Lua", ".lua");
new Language("MoonScript", ".moon", (filePath) => __awaiter(this, void 0, void 0, function* () { return (yield child_process.exec("moonc -p " + filePath))[0]; }));
//# sourceMappingURL=Language.js.map