/// <reference types="node" />
import http = require("http");
import { Change, Remove } from "../types";
import Project from "./Project";
export default class Client {
    id: string;
    placeId: number;
    private static readonly _instances;
    static readonly instances: ReadonlyArray<Client>;
    private sendQueue;
    private response?;
    constructor(id: string, placeId: number);
    private getProjectQueue;
    fullSyncProjectToStudio(project: Project): Promise<void>;
    fullSyncAllToStudio(): Promise<void>;
    remove(): void;
    writeResponse(): void;
    setResponse(res: http.ServerResponse): void;
    syncToStudio(projectName: string, changes: Array<Change | Remove>): void;
    disconnect(res?: http.ServerResponse): void;
}
