import { Change, Remove } from "../types";
import Partition from "./Partition";
export default class Project {
    private static readonly _instances;
    static readonly instances: ReadonlyArray<Project>;
    private configWatcher?;
    private isRunning;
    private allowAnyPlaceId;
    private _placeIds;
    readonly placeIds: ReadonlySet<number>;
    readonly directory: string;
    readonly partitions: Partition[];
    name: string;
    loaded: boolean;
    constructor(directory: string);
    private getConfigPath;
    private setup;
    remove(): Promise<void>;
    isValidPlaceId(placeId: number): boolean;
    private applyConfig;
    private readConfig;
    distributeChangeToStudio(change: Change | Remove): Promise<void>;
    start(): Promise<void>;
    stop(): Promise<void>;
}
